diff --git xscreensaver-5.12/driver/timers.c xscreensaver-5.12/driver/timers.c
--- xscreensaver-5.12/driver/timers.c
+++ xscreensaver-5.12/driver/timers.c
@@ -47,6 +47,8 @@
 #endif /* HAVE_RANDR */
 
 #include "xscreensaver.h"
+#include "types.h"
+#include "dialog-data.h"
 
 #undef ABS
 #define ABS(x)((x)<0?-(x):(x))
@@ -60,6 +62,11 @@ static Bool proc_interrupts_activity_p (saver_info *si);
 #endif /* HAVE_PROC_INTERRUPTS */
 
 static void check_for_clock_skew (saver_info *si);
+#ifdef HAVE_XSCREENSAVER_LOCK
+static void watchdog_timer (XtPointer closure, XtIntervalId *id);
+extern Bool g_passwd_dialog_created;
+extern Bool ok_to_unblank;
+#endif
 
 
 void
@@ -255,7 +262,11 @@ cycle_timer (XtPointer closure, XtIntervalId *id)
        crash.  So, restart the thing once an hour. */
     how_long = 1000 * 60 * 60;
 
+#ifdef HAVE_XSCREENSAVER_LOCK
+  if (si->external_passwd)
+#else
   if (si->dbox_up_p)
+#endif
     {
       if (p->verbose_p)
 	fprintf (stderr, "%s: dialog box up; delaying hack change.\n",
@@ -308,7 +319,28 @@ activate_lock_timer (XtPointer closure, XtIntervalId *id)
 
   if (p->verbose_p)
     fprintf (stderr, "%s: timed out; activating lock.\n", blurb());
-  set_locked_p (si, True);
+
+  if (si->locked_p)
+    {
+      if (p->verbose_p)
+        fprintf (stderr,
+          "-->activate_lock_timer returning because screen already locked\n");
+      return;
+    }
+
+  /* Make sure screen is blanked before posting dialog box */
+  if (si->screen_blanked_p)
+    {
+      set_locked_p (si, True);
+      ok_to_unblank = unlock_p (si);
+      if (ok_to_unblank == True)
+        {
+          set_locked_p(si,False);
+          unblank_screen(si);
+        }
+    }
+  else /* blanking of screen failed reset lock flag */
+    set_locked_p (si, False);
 }
 
 
@@ -587,14 +619,30 @@ dispatch_event (saver_info *si, XEvent *event)
 }
 
 
+#ifdef HAVE_XSCREENSAVER_LOCK
+void /* called from lock.c */
+#else
 static void
+#endif
 swallow_unlock_typeahead_events (saver_info *si, XEvent *e)
 {
   XEvent event;
   char buf [100];
   int i = 0;
 
+#ifdef HAVE_XSCREENSAVER_LOCK
+  if (!si->typeahead_events)
+    {
+      /* Allocate enough space for 10 keys to be queued - if we get more
+         than that before the dialog is ready, it's most likely the user
+         left something sitting on the keyboard, and won't want them. */
+      si->typeahead_events = calloc(10, sizeof(XKeyEvent));
+      if (si->typeahead_events == NULL)
+        return;
+    }
+#else
   memset (buf, 0, sizeof(buf));
+#endif
 
   event = *e;
 
@@ -607,10 +655,12 @@ swallow_unlock_typeahead_events (saver_info *si, XEvent *e)
           if (size != 1) continue;
           switch (*s)
             {
+#ifndef HAVE_XSCREENSAVER_LOCK /* Let these be queued with the rest */
             case '\010': case '\177':			/* Backspace */
               if (i > 0) i--;
               break;
             case '\025': case '\030':			/* Erase line */
+#endif
             case '\012': case '\015':			/* Enter */
             case '\033':				/* ESC */
               i = 0;
@@ -620,7 +670,17 @@ swallow_unlock_typeahead_events (saver_info *si, XEvent *e)
                 break;  /* ignore space at beginning of line */
               /* else, fall through */
             default:
+#ifdef HAVE_XSCREENSAVER_LOCK
+              /* Queue events to replay once dialog is ready */
+              if (si->num_typeahead_events < 10)
+                memcpy (&si->typeahead_events[si->num_typeahead_events++],
+                        &event, sizeof(XKeyEvent));
+              else
+                XBell (si->dpy, 0);
+              i = 1; /* so that spaces are accepted after the beginning */
+#else
               buf [i++] = *s;
+#endif
               break;
             }
         }
@@ -628,6 +688,7 @@ swallow_unlock_typeahead_events (saver_info *si, XEvent *e)
     } while (i < sizeof(buf)-1 &&
              XCheckMaskEvent (si->dpy, KeyPressMask, &event));
 
+#ifndef HAVE_XSCREENSAVER_LOCK
   buf[i] = 0;
 
   if (si->unlock_typeahead)
@@ -642,6 +703,7 @@ swallow_unlock_typeahead_events (saver_info *si, XEvent *e)
     si->unlock_typeahead = 0;
 
   memset (buf, 0, sizeof(buf));
+#endif /* HAVE_XSCREENSAVER_LOCK */
 }
 
 
@@ -818,7 +880,10 @@ sleep_until_idle (saver_info *si, Bool until_idle_p)
 
       case ClientMessage:
 	if (handle_clientmessage (si, &event.x_event, until_idle_p))
-	  goto DONE;
+          {
+            si->emergency_lock_p = True;
+            goto DONE;
+          }
 	break;
 
       case CreateNotify:
@@ -831,6 +896,47 @@ sleep_until_idle (saver_info *si, Bool until_idle_p)
 	  }
 	break;
 
+      case VisibilityNotify:
+      {
+        int k;
+
+        if (p->debug_p)
+          {
+            fprintf (stderr,
+                     "************************************\n"
+                     "-->sleep_until_idle() event:VisibilityNotify\n"
+                     "\t Window of VisibilityNotify:%x\n"
+                     "\t until_idle_p=%d g_passwd_dialog_created=%d\n",
+                     event.x_event.xvisibility.window,
+                     until_idle_p, g_passwd_dialog_created);
+            fflush(stderr);
+          }
+
+        /* Don't raise root window when passwd dialog wants to come up */
+        if (g_passwd_dialog_created == 0 && !until_idle_p)
+          {
+            if (event.x_event.xvisibility.state != VisibilityUnobscured)
+              {
+                for (k = 0; k < si->nscreens; k++)
+                  {
+                    saver_screen_info *ssi = &si->screens[k];
+                    XClearWindow (si->dpy, ssi->screensaver_window);
+                    clear_stderr (ssi);
+                    XMapRaised (si->dpy, ssi->screensaver_window);
+                  }
+                if (p->debug_p)
+                  {
+                    fprintf (stderr,
+                             "A window is trying to popup.\n"
+                             "Raising saver root Window.\n"
+                             "************************************\n");
+                    fflush(stderr);
+                  }
+              }
+          }
+        break;
+      }
+
       case KeyPress:
       case ButtonPress:
       /* Ignore release events so that hitting ESC at the password dialog
@@ -1419,7 +1525,11 @@ watchdog_timer (XtPointer closure, XtIntervalId *id)
     {
       Bool running_p = screenhack_running_p (si);
 
+#ifdef HAVE_XSCREENSAVER_LOCK
+      if (si->external_passwd)
+#else
       if (si->dbox_up_p)
+#endif
         {
           if (si->prefs.debug_p)
             fprintf (stderr, "%s: dialog box is up: not raising screen.\n",
diff --git xscreensaver-5.12/driver/types.h xscreensaver-5.12/driver/types.h
--- xscreensaver-5.12/driver/types.h
+++ xscreensaver-5.12/driver/types.h
@@ -248,12 +248,30 @@ struct saver_info {
 
   int unlock_failures;		/* Counts failed login attempts while the
 				   screen is locked. */
+#ifdef HAVE_XSCREENSAVER_LOCK
+  Window *raise_wins;		/* List of windows to raise above the	*/
+  int num_raise_wins;		/*  virtual root/hack display, such as	*/
+  int max_raise_wins;		/*  accessibility helpers		*/
+
+  Window *override_wins;        /* Windows we had to unset the          */
+  int num_override_wins;        /*  override_redirect attribute on and  */
+  int max_override_wins;        /*  need to restore it on after unlock. */
+
+
+  pid_t passwd_pid;             /* The pid of the password dialog child if we
+                                   are running an external process for it. */
+  Bool external_passwd;
+
+  XKeyEvent *typeahead_events;	/* Like unlock_typeahead, but as raw events */
+  int num_typeahead_events;
+#else
 
   char *unlock_typeahead;	/* If the screen is locked, and the user types
                                    a character, we assume that it is the first
                                    character of the password.  It's stored here
                                    for the password dialog to use to populate
                                    itself. */
+#endif /* HAVE_XSCREENSAVER_LOCK */
 
   char *user;			/* The user whose session is locked. */
   char *cached_passwd;		/* Cached password, used to avoid multiple
diff --git xscreensaver-5.12/driver/windows.c xscreensaver-5.12/driver/windows.c
--- xscreensaver-5.12/driver/windows.c
+++ xscreensaver-5.12/driver/windows.c
@@ -1081,8 +1081,12 @@ safe_XConfigureWindow (Display *dpy, Window window,
   return (!error_handler_hit_p);
 }
 
+#ifdef HAVE_XSCREENSAVER_LOCK
+Bool
+#else
 /* This might not be necessary, but just in case. */
 static Bool
+#endif
 safe_XDestroyWindow (Display *dpy, Window window)
 {
   XErrorHandler old_handler;
@@ -1096,6 +1100,14 @@ safe_XDestroyWindow (Display *dpy, Window window)
   XSetErrorHandler (old_handler);
   XSync (dpy, False);
 
+  /* clear any queued VisibilityNotify events so we don't cause XErrors
+     later when we try to process them and find the windowid is invalid */
+  XEvent event;
+  while (XCheckWindowEvent(dpy, window, VisibilityChangeMask, &event))
+    {
+      /* discard event */ ;
+    }
+
   return (!error_handler_hit_p);
 }
 
@@ -1210,6 +1222,7 @@ initialize_screensaver_window_1 (saver_screen_info *ssi)
    */
   attrs.event_mask = (KeyPressMask | KeyReleaseMask |
 		      ButtonPressMask | ButtonReleaseMask |
+		      VisibilityChangeMask |
 		      PointerMotionMask);
 
   attrs.backing_store = NotUseful;
@@ -1481,6 +1494,9 @@ raise_window (saver_info *si,
   saver_preferences *p = &si->prefs;
   int i;
 
+  if (p->verbose_p)
+      fprintf(stderr,"-->raise_window()\n");
+
   if (si->demoing_p)
     inhibit_fade = True;
 
@@ -1695,6 +1711,9 @@ unblank_screen (saver_info *si)
   Bool unfade_p = (si->fading_possible_p && p->unfade_p);
   int i;
 
+  if (p->verbose_p)
+      fprintf(stderr,"-->unblank_screen()\n");
+
   monitor_power_on (si);
   reset_watchdog_timer (si, False);
 
@@ -1983,7 +2002,7 @@ select_visual (saver_screen_info *ssi, const char *visual_name)
       maybe_transfer_grabs (ssi, old_w, ssi->screensaver_window, ssi->number);
 
       /* Now we can destroy the old window without horking our grabs. */
-      XDestroyWindow (si->dpy, old_w);
+      safe_XDestroyWindow (si->dpy, old_w);
 
       if (p->verbose_p)
 	fprintf (stderr, "%s: %d: destroyed old saver window 0x%lx.\n",
diff --git xscreensaver-5.12/driver/xscreensaver.c xscreensaver-5.12/driver/xscreensaver.c
--- xscreensaver-5.12/driver/xscreensaver.c
+++ xscreensaver-5.12/driver/xscreensaver.c
@@ -156,6 +156,8 @@
 #include <X11/StringDefs.h>
 #include <X11/Shell.h>
 #include <X11/Xos.h>
+#include <gconf/gconf-client.h>
+#include <glib.h>
 #include <time.h>
 #include <sys/time.h>
 #include <netdb.h>	/* for gethostbyname() */
@@ -217,6 +219,7 @@
 #endif /* HAVE_RANDR */
 
 
+#include "dialog-data.h"
 #include "xscreensaver.h"
 #include "version.h"
 #include "yarandom.h"
@@ -228,11 +231,28 @@
 
 saver_info *global_si_kludge = 0;	/* I hate C so much... */
 
+/* Globals */
+Bool ok_to_unblank = False;
+
+#ifdef HAVE_XSCREENSAVER_LOCK
+/* Global storage for gtk passwd lock dialog
+ * we assign this to si->pw_data and this is needed
+ * to set user/passwd labels on gtk lock dialog by
+ * pam conv function.
+ */
+passwd_dialog_data mygtkpwd;
+passwd_dialog_data *ptr_mygtkpwd = &mygtkpwd;
+#endif
+
 char *progname = 0;
 char *progclass = 0;
 XrmDatabase db = 0;
 
 
+#ifdef HAVE_XSCREENSAVER_LOCK
+Atom XA_UNLOCK_RATIO;
+#endif
+
 
 static XrmOptionDescRec options [] = {
 
@@ -630,6 +650,9 @@ connect_to_server (saver_info *si, int *argc, char **argv)
 	{ &XA_XSETROOT_ID, "_XSETROOT_ID" },
 	{ &XA_ESETROOT_PMAP_ID, "ESETROOT_PMAP_ID" },
 	{ &XA_XROOTPMAP_ID, "_XROOTPMAP_ID" },
+#ifdef HAVE_XSCREENSAVER_LOCK
+	{ &XA_UNLOCK_RATIO, "UNLOCK_RATIO" },
+#endif
 	{ NULL, NULL } /* Must be last to terminate list */
       };
     const struct atom_request *atom_lists[3] = { NULL, NULL, NULL };
@@ -1105,8 +1128,36 @@ static void
 main_loop (saver_info *si)
 {
   saver_preferences *p = &si->prefs;
-  Bool ok_to_unblank;
+  /* Bool ok_to_unblank; made this a global flag, gets set in timers.c */
   int i;
+  const char *modulesptr = NULL;
+
+/*
+** CR4784055(P1)locked-screen dialog is inaccessible to Gnopernicus
+** voice for each type-in char in the password field of
+** pop-up dialog
+*/
+
+  /* BUG #6573182
+  ** g_type_init should be done before calling gconf_client routines
+  ** so that xscreensaver does not dump core if gconf daemon is not running.
+  */
+  g_type_init ();
+
+  /*
+  ** 6395649 at-spi-registryd starts when screen is locked even
+  ** when accessible device support is off(SR)
+  ** per AT core gp suggestion
+  ** GTK_MODULES is set only if at support is enabled
+  */
+
+  if (gconf_client_get_bool(gconf_client_get_default(),
+			    "/desktop/gnome/interface/accessibility", NULL))
+    {
+      modulesptr = getenv ("GTK_MODULES");
+      if (!modulesptr || modulesptr [0] == '\0')
+	putenv ("GTK_MODULES=gail:atk-bridge");
+    }
 
   while (1)
     {
@@ -1137,6 +1188,17 @@ main_loop (saver_info *si)
             fprintf (stderr, "%s: idle with blanking disabled at %s.\n",
                      blurb(), timestring());
 
+          /* 6221109 Changing mode from disable to anything else,
+             doesn't lock screen.
+
+             This is Disable Screen Saver mode, in this mode we dont lock
+             screen, but si->locked_p is already set to True, since someone
+             tried to lock screen, reset it to False, else when we change
+             mode from disable and try to lock screen, xscreensaver thinks
+             screen is already locked and doesnt lock screen anymore.
+           */
+          set_locked_p (si, False);
+
           /* Go around the loop and wait for the next bout of idleness,
              or for the init file to change, or for a remote command to
              come in, or something.
@@ -1198,6 +1260,7 @@ main_loop (saver_info *si)
                        blurb());
 
               schedule_wakeup_event (si, retry, p->debug_p);
+              set_locked_p(si, False);
               continue;
             }
         }
@@ -1246,7 +1309,17 @@ main_loop (saver_info *si)
             p->lock_p &&                /* and locking is enabled */
             !si->locking_disabled_p &&  /* and locking is possible */
             lock_timeout == 0)          /* and locking is not timer-deferred */
-          set_locked_p (si, True);      /* then lock right now. */
+          {
+           if (p->debug_p)
+             fprintf(stderr, "going to lock screen B\n");
+           set_locked_p (si, True);      /* then lock right now. */
+           ok_to_unblank = unlock_p(si);
+           if (ok_to_unblank == True)
+             {
+               set_locked_p (si, False);
+               goto DONE;
+             }
+          }
 
         /* locked_p might be true already because of the above, or because of
            the LOCK ClientMessage.  But if not, and if we're supposed to lock
@@ -1261,10 +1334,7 @@ main_loop (saver_info *si)
       }
 #endif /* !NO_LOCKING */
 
-
-      ok_to_unblank = True;
       do {
-
         check_for_leaks ("blanked A");
 	sleep_until_idle (si, False);		/* until not idle */
         check_for_leaks ("blanked B");
@@ -1274,6 +1344,13 @@ main_loop (saver_info *si)
 #ifndef NO_LOCKING
         /* Maybe unlock the screen.
          */
+        if (si->demoing_p) goto DONE; /* in demoing mode and user wants out
+                                         unblank screen */
+
+        /* This is when blank timeout has happened but lock timeout hasnt
+           and user gets active.  Simply get him out of the blank screen. */
+        if (si->screen_blanked_p && !si->locked_p) goto DONE;
+
 	if (si->locked_p)
 	  {
 	    saver_screen_info *ssi = si->default_screen;
@@ -1285,7 +1362,20 @@ main_loop (saver_info *si)
               suspend_screenhack (&si->screens[i], True);	  /* suspend */
 	    XUndefineCursor (si->dpy, ssi->screensaver_window);
 
+#ifdef HAVE_XSCREENSAVER_LOCK
+            /* Prevents lock dialog posting on non blanked screen */
+            if (!si->screen_blanked_p)  /* locked_p is true, so blank now */
+              blank_screen (si);
+            if (si->screen_blanked_p)   /* if blanking successful, call PAM */
+              {
+                set_locked_p (si, True);
+                ok_to_unblank = unlock_p(si);
+              }
+            else /* blanking failed, probably couldn't grab keyboard/mouse */
+              set_locked_p (si, False);
+#else
 	    ok_to_unblank = unlock_p (si);
+#endif
 
 	    si->dbox_up_p = False;
 	    XDefineCursor (si->dpy, ssi->screensaver_window, ssi->cursor);
@@ -1310,6 +1400,7 @@ main_loop (saver_info *si)
 
 	} while (!ok_to_unblank);
 
+DONE:
 
       if (p->verbose_p)
 	fprintf (stderr, "%s: unblanking screen at %s.\n",
@@ -1375,7 +1466,19 @@ main (int argc, char **argv)
   textdomain (GETTEXT_PACKAGE);
 #endif /* ENABLE_NLS */
 
+#if defined(ENABLE_NLS) && defined(HAVE_XSCREENSAVER_LOCK)
+  /* Gtk unlock dialog needs to be sent UTF-8 text to display */
+  bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
+#endif
+
   memset(si, 0, sizeof(*si));
+
+#ifdef HAVE_XSCREENSAVER_LOCK
+/* Initialize and point si to pw_data i.e. the lock dialog struct */
+  memset(ptr_mygtkpwd, 0, sizeof(*ptr_mygtkpwd));
+  si->pw_data = ptr_mygtkpwd;
+#endif
+
   global_si_kludge = si;	/* I hate C so much... */
 
   fix_fds();
@@ -1385,7 +1488,9 @@ main (int argc, char **argv)
 
   save_argv (argc, argv);
   set_version_string (si, &argc, argv);
+#ifndef HAVE_XSCREENSAVER_LOCK /* moved below for external lock */
   privileged_initialization (si, &argc, argv);
+#endif
   hack_environment (si);
 
   spasswd = getpwuid(getuid());
@@ -1408,6 +1513,10 @@ main (int argc, char **argv)
   print_banner (si);
 
   load_init_file(si->dpy, p); /* must be before initialize_per_screen_info() */
+#ifdef HAVE_XSCREENSAVER_LOCK
+  privileged_initialization (si, &argc, argv);
+#endif
+
   blurb_timestamp_p = p->timestamp_p;  /* kludge */
   initialize_per_screen_info (si, shell); /* also sets si->fading_possible_p */
 
@@ -1659,8 +1768,12 @@ handle_clientmessage (saver_info *si, XEvent *event, Bool until_idle_p)
   Atom type = 0;
   Window window = event->xclient.window;
 
+  if (p->verbose_p)
+     fprintf(stderr, "handle_clientmessage\n");
+
   /* Preferences might affect our handling of client messages. */
   maybe_reload_init_file (si);
+  XSync (si->dpy, False);
 
   if (event->xclient.message_type != XA_SCREENSAVER ||
       event->xclient.format != 32)
@@ -1933,10 +2046,18 @@ handle_clientmessage (saver_info *si, XEvent *event, Bool until_idle_p)
 			    : "locking.");
 	  sprintf (buf, "LOCK ClientMessage received; %s", response);
 	  clientmessage_response (si, window, False, buf, response);
+
+	  if (p->verbose_p)
+	    fprintf(stderr, "going to lock screen A\n");
+
 	  set_locked_p (si, True);
+	  si->emergency_lock_p = True;
 	  si->selection_mode = 0;
 	  si->demoing_p = False;
 
+	  return True; /* dont set lock_id to 0,
+                          causes to go in lock in main_loop above */
+
 	  if (si->lock_id)	/* we're doing it now, so lose the timeout */
 	    {
 	      XtRemoveTimeOut (si->lock_id);
diff --git xscreensaver-5.12/driver/xscreensaver.h xscreensaver-5.12/driver/xscreensaver.h
--- xscreensaver-5.12/driver/xscreensaver.h
+++ xscreensaver-5.12/driver/xscreensaver.h
@@ -164,6 +164,12 @@ extern Bool select_visual (saver_screen_info *ssi, const char *visual_name);
 extern void store_saver_status (saver_info *si);
 extern const char *signal_name (int signal);
 
+#ifdef HAVE_XSCREENSAVER_LOCK
+extern int kill_job (saver_info *si, pid_t pid, int signal);
+extern struct screenhack_job *make_job (pid_t pid, int screen,
+                                        const char *cmd);
+#endif
+
 /* =======================================================================
    subprocs diagnostics
    ======================================================================= */

